## $Id: interfaces.py 7695 2012-02-23 17:48:43Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import zope.i18nmessageid
from zope import schema
from waeup.sirp.interfaces import (
    ISessionConfiguration, academic_sessions_vocab)

_ = MessageFactory = zope.i18nmessageid.MessageFactory('waeup.custom')

# It's recommended to replicate all fields from the base package here.
class ISessionConfiguration(ISessionConfiguration):
    """A session configuration object.
    """

    school_fee_base = schema.Int(
        title = _(u'School Fee (ignored)'),
        default = 0,
        )

    surcharge_1 = schema.Int(
        title = _(u'Surcharge BT'),
        default = 0,
        )

    surcharge_2 = schema.Int(
        title = _(u'Surcharge Interswitch'),
        default = 0,
        )

    surcharge_3 = schema.Int(
        title = _(u'Surcharge 3'),
        default = 0,
        )

    clearance = schema.Int(
        title = _(u'Clearance Fee'),
        default = 0,
        )

    booking_fee = schema.Int(
        title = _(u'Booking Fee'),
        default = 0,
        )

    maint_fee = schema.Int(
        title = _(u'Maintenance Fee'),
        default = 0,
        )

    gown = schema.Int(
        title = _(u'Gown Fee'),
        default = 0,
        )

    transfer = schema.Int(
        title = _(u'Transfer Fee'),
        default = 0,
        )

    def getSessionString():
        """Returns the session string from the vocabulary.
        """


class ISessionConfigurationAdd(ISessionConfiguration):
    """A session configuration object in add mode.
    """

    academic_session = schema.Choice(
        title = _(u'Academic Session'),
        source = academic_sessions_vocab,
        default = None,
        required = True,
        readonly = False,
        )

ISessionConfigurationAdd['academic_session'].order =  ISessionConfiguration[
    'academic_session'].order